package com.kohabi.hnbrowser;

import android.view.LayoutInflater;
import android.widget.BaseAdapter;

import java.util.ArrayList;
import java.util.List;

public abstract class ArrayAdapter<T> extends BaseAdapter {
	protected final LayoutInflater inflater;
	private final List<T> data = new ArrayList<T>();

	public ArrayAdapter(LayoutInflater inflater) {
		super();
		this.inflater = inflater;
	}

	public void clear() {
		data.clear();
		notifyDataSetChanged();
	}

	public void add(T article) {
		data.add(article);
		notifyDataSetChanged();
	}

	@Override public long getItemId(int position) {
		return position;
	}

	@Override public int getCount() {
		return data.size();
	}

	@Override public T getItem(int position) {
		return data.get(position);
	}
}
