package com.kohabi.hnbrowser;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

public class ArticleAdapter extends ArrayAdapter<Article> {
	public ArticleAdapter(LayoutInflater inflater) {
		super(inflater);
	}

	@Override public View getView(int position, View convertView, ViewGroup parent) {
		if (convertView == null) {
			convertView = inflater.inflate(R.layout.news_feed_item, null);
		}
		Article article = getItem(position);
		// set title
		TextView title = (TextView) convertView.findViewById(R.id.news_feed_item_title);
		title.setText(article.title);
		// set comHead
		TextView comHead = (TextView) convertView.findViewById(R.id.news_feed_item_comhead);
		if (article.comHead.equals("")) {
			comHead.setVisibility(View.GONE);
		} else {
			comHead.setText(article.comHead);
			comHead.setVisibility(View.VISIBLE);
		}
		// set subtext
		TextView subtext = (TextView) convertView.findViewById(R.id.news_feed_item_subtext);
		subtext.setText(article.subtext);
		return convertView;
	}
}
