package com.kohabi.hnbrowser;

import android.content.Context;
import android.support.v4.content.AsyncTaskLoader;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class ArticleLoader extends AsyncTaskLoader<Either<Exception, List<Article>>> {
	public ArticleLoader(Context context) {
		super(context);
	}

	@Override public Either<Exception, List<Article>> loadInBackground() {
		try {
			List<Article> articles = new ArrayList<Article>();
			Document doc = Jsoup.connect("http://news.ycombinator.com").timeout(10000).get();
			// map links
			Elements links = doc.select("td.title > a[href!=news2]:first-child");
			for (Iterator<Element> it = links.iterator(); it.hasNext();) {
				Element link = it.next();
				Element comHead = link.lastElementSibling();
				Article a = new Article();
				a.title = link.text();
				a.url = link.attr("href");
				a.comHead = comHead == null ? "" : comHead.text();
				articles.add(a);
			}
			// add subtexts
			Elements subtexts = doc.select("td.subtext");
			int i = 0;
			for (Iterator<Element> it = subtexts.iterator(); it.hasNext(); i++) {
				Element subtext = it.next();
				Article a = articles.get(i);
				a.subtext = subtext.text();
				a.commentsUri = subtext.children().last().attr("href");
			}
			return Either.right(articles);
		} catch (Exception e) {
			return Either.left(e);
		}
	}
}
