package com.kohabi.hnbrowser;

import android.content.Context;
import android.support.v4.content.AsyncTaskLoader;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class CommentLoader extends AsyncTaskLoader<Either<Exception, List<Comment>>> {
	private final String uri;

	public CommentLoader(Context context, String uri) {
		super(context);
		this.uri = uri;
	}

	@Override public Either<Exception, List<Comment>> loadInBackground() {
		try {
			List<Comment> comments = new ArrayList<Comment>();
			String host = "http://news.ycombinator.com/" + uri;
			Document doc = Jsoup.connect(host).timeout(10000).get();
			Elements commentElements = doc.select("span.comment");
			for (Iterator<Element> it = commentElements.iterator(); it.hasNext();) {
				Element commentElement = it.next();
				Comment comment = new Comment();
				comment.body = commentElement.text();
				comments.add(comment);
			}
			return Either.right(comments);
		} catch (Exception e) {
			return Either.left(e);
		}
	}
}
