package com.kohabi.hnbrowser;

import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.support.v4.app.LoaderManager.LoaderCallbacks;
import android.support.v4.content.Loader;
import android.widget.ListView;

import java.util.List;

public class CommentsActivity extends FragmentActivity
		implements LoaderCallbacks<Either<Exception, List<Comment>>> {
	private ListView listView;
	private CommentAdapter adapter;
	private ProgressDialog dialog;
	private String uri;
	public final static String COMMENTS_URI = CommentsActivity.class + "COMMENTS_URI";

	@Override protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.comments_activity);
		uri = getIntent().getExtras().getString(COMMENTS_URI);
		adapter = new CommentAdapter(getLayoutInflater());
		listView = (ListView) findViewById(R.id.comment_list);
		listView.setAdapter(adapter);
		refresh();
	}

	private void refresh() {
		adapter.clear();
		dialog = new ProgressDialog(this);
		dialog.setTitle("Loading..");
		dialog.setMessage("Please wait.");
		dialog.setCancelable(false);
		dialog.setIndeterminate(true);
		dialog.show();
		getSupportLoaderManager().restartLoader(0, null, this).forceLoad();
	}

	@Override public Loader<Either<Exception, List<Comment>>> onCreateLoader(int id, Bundle args) {
		return new CommentLoader(this, uri);
	}

	@Override public void onLoaderReset(Loader<Either<Exception, List<Comment>>> loader) {}

	@Override public void onLoadFinished(Loader<Either<Exception, List<Comment>>> loader,
	                                     Either<Exception, List<Comment>> data) {
		dialog.dismiss();
		if (data.isLeft()) {
			Exception e = data.getLeft();
			(new AlertDialog.Builder(this))
				.setTitle("Error")
				.setMessage(e.toString())
				.setCancelable(true)
				.setPositiveButton("Okay", new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface d, int id) {
						d.cancel();
					}
				}).create().show();
		} else {
			List<Comment> comments = data.getRight();
			for (Comment c : comments) {
				adapter.add(c);
			}
		}
	}
}
